controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Noticias;
use yii\data\ActiveDataProvider;
use app\models\Formulario;
use app\models\Comentarios;
use app\models\NoticiasFotos;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use app\models\Fotos;
use yii\web\UploadedFile;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Noticias::find()]);
        return $this->render("index",["dataProvider" => $dataProvider]);
         
    }
    
    public function actionAnadircomentario($codigo)
    {
        $model = new Comentarios();

        if ($model->load(Yii::$app->request->post())) {
            $model->noticias_codigo=$codigo;
            if ($model->save()) 
            {
                return $this->redirect(["site/vercomentarios","codigo"=>$codigo]);
            }
        }

        return $this->render('formulario', [
            'model' => $model,
        ]);
    
    }
    
    public function actionVercomentarios($codigo)
    {
        $noticia= Noticias::findOne($codigo);
        $dataProvider = new ActiveDataProvider([
        'query' => Comentarios::find()->where(['noticias_codigo' => $codigo])]);
        return $this->render("listar",["dataProvider" => $dataProvider,"noticia" => $noticia]);
    }
    
    public function actionEditarcomentario($codigo)
    {
        $model=Comentarios::findOne($codigo);
        
        if($this->request->isPost)
        {
            if ($model->load(Yii::$app->request->post())) {
                if ($model->save()) 
                {
                    return $this->redirect(["site/vercomentarios","codigo"=>$model->noticias_codigo]);
                }
            }
        }
        
        return $this->render('formulario', [
            'model' => $model,
        ]);
                
    }
    
    public function actionEliminarcomentario($codigo)
    {
        $model=Comentarios::findOne($codigo);
        $noticias_codigo=$model->noticias_codigo;
        $model->delete();
        return $this->redirect(["site/vercomentarios","codigo"=>$noticias_codigo]);
    }
    
    public function actionNuevanoticia()
    {
        $model=new Noticias();
        $model_2=new NoticiasFotos();
        
        if ($model->load(Yii::$app->request->post())) 
        {
            if ($model->validate()) {
                $model->save();
                return $this->redirect(["site/index"]);
                }
        }

        return $this->render('formulario_noticias', [
            'model' => $model,
        ]);
    }
    
    public function actionEditarnoticia($codigo)
    {
        $model= Noticias::findOne($codigo);
        
        if ($model->load(Yii::$app->request->post())) 
        {
            if ($model->validate()) {
                $model->save();
                return $this->redirect(["site/index"]);
                }
        }

        return $this->render('formulario_noticias', [
            'model' => $model,
        ]);
    }
    
    public function actionEliminarnoticia($codigo)
    {
        $model=Noticias::findOne($codigo);
        $model->delete();
        return $this->redirect(["site/index"]);
    }
    
    public function actionConfirmareliminarnoticia($codigo)
    {
        $model=Noticias::findOne($codigo);
        
        return $this->render("ver",['model'=> $model]);
    }

    public function actionAnadirfoto()
    {
        $model = new Fotos();

        if ($model->load(Yii::$app->request->post())) {
            echo "<br><br><br><br><br>";
            var_dump($model);
            $model->nombre=UploadedFile::getInstance($model,"nombre");
 
            if ($model->save()) {
                 return $this->redirect(["site/index"]);
            }
            
            
        }

        return $this->render('formulario_fotos', [
            'model' => $model,
        ]);
    }
    
    public function actionEditarfoto($codigo)
    {
        $model = Fotos::findOne($codigo);
        if($this->request->post())
        {
            if ($model->load(Yii::$app->request->post())) 
            {
                $model->nombre=UploadedFile::getInstance($model,"nombre");

                if ($model->save()) {
                     return $this->redirect(["site/verfotos"]);
                }
            }
        }
    }
    
    public function actionEliminarfoto($codigo)
    {
        $model= Fotos::findOne($codigo);
        $model->delete();
        return $this->redirect(["site/verfotos"]);
        
    }
    
    public function actionVerfotos()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Fotos::find()]);
        return $this->render("listar_fotos",["dataProvider" => $dataProvider]);
    }
    
    public function actionNoticiasfotos()
    {
        $model=new NoticiasFotos();
        
        if ($model->load(Yii::$app->request->post())) 
        {
            $correcto=[];
            foreach ($model->fotos_codigo as $foto)
            {
                $modelo=new NoticiasFotos();
                $modelo->noticias_codigo=$model->noticias_codigo;
                $modelo->fotos_codigo=$foto;
                if($modelo->save())
                {
                    $correcto[]=Fotos::findOne($foto)->nombre;
                }
            }
            
            if (count($correcto)>0) {
                return $this->render('salidanoticiafotos',[
                    'correctas'=>$correcto,
                ]);
            }else{
                $model->addError("cod_foto","todas las fotos estan ya en la noticia");
            }

        }
        $noticias= Noticias::find()->all();
        $listar_noticias= ArrayHelper::map($noticias,'codigo',function($model)
        {
            return $model->codigo . "-" . $model->titulo; 
        }
        );
        

        $fotos= Fotos::find()->all();
        
        $listar_fotos= ArrayHelper::map($fotos,'codigo',function($model){
                return Html::img("@web/imgs/" . $model->nombre,["class"=>'col-lg-10 img-fluid']);
            });

        return $this->render('noticias_fotos', [
            'model' => $model,
            'listar_noticias' => $listar_noticias,
            'listar_fotos' => $listar_fotos,
        ]);
    }
    
    

    
}

views/site/_noticias.php
<?php
use yii\helpers\Html;
use yii\bootstrap4\Carousel;
?>

<div class="row">
    <div class="col-lg-12">
        <h2><?= $model->titulo ?><br></h2>
        <div class="bg-warning rounded p-2">Fecha:</div>
        <div class="p-1"><?= $model->fecha ?></div>
        <div class="bg-warning rounded p-2">Contenido:</div>
        <div class="p-1 mb-4"><?= $model->texto ?></div>
    </div>
</div>

<?php
$carousel=[];
$fotos=$model->getFotosCodigos()->all();//obteniendo datos de otra tabla con la que está relaccionada
foreach($fotos as $foto)
{
    $carousel[]=Html::img("@web/imgs/$foto->nombre",["width"=>300,"height"=>200]);
}

if(count($carousel)==0)
{
    echo Html::img("@web/imgs/imagen1.jpg",["width"=>300,"height"=>200]);
    echo "<br>";
}else
{
    echo Carousel::widget([
        'items' => $carousel,
        'options'=>[
            'class' => 'mx-auto col-lg-8'
        ],
        'controls' => ['<i class="fas fa-arrow-left fa-3x"></i>','<i class="fas fa-arrow-right fa-3x"></i>']
    ]);
}
?>
<br>
<?= Html::a("Añadir Comentario",["site/anadircomentario", 'codigo' => $model->codigo], ['class' => 'btn btn-primary']) ?>
&nbsp
<?= Html::a("Ver Comentarios",["site/vercomentarios", 'codigo' => $model->codigo], ['class' => 'btn btn-primary']) ?>
<br><br>
<?= Html::a("Editar Noticia",["site/editarnoticia", 'codigo' => $model->codigo]) ?>
&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
<?= Html::a("Eliminar Noticia",["site/confirmareliminarnoticia", 'codigo' => $model->codigo]) ?>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/formulario.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Formulario */
/* @var $form ActiveForm */
?>
<div class="formulario">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'texto')->textarea() ?>
    
        <div class="form-group">
            <?= Html::submitButton('Añadir Comentario', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- formulario -->

views/site/formulario_fotos.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Fotos */
/* @var $form ActiveForm */
?>
<div class="site-formulario_fotos">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model,"nombre")->fileInput() ?>
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario_fotos -->

views/site/formulario_noticias.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Noticias */
/* @var $form ActiveForm */
?>
<div class="formulario_noticias">

    <?php $form = ActiveForm::begin(); ?>
        
        <?= $form->field($model, 'fecha') ?>
        <?= $form->field($model, 'titulo') ?>
        <?= $form->field($model, 'texto') ?>
    
        
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- formulario_noticias -->

views/site/index.php
<?php
use yii\widgets\ListView;
use yii\helpers\Html;

?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Noticias</h1>

<?= Html::a("Nueva Noticia",["site/nuevanoticia"], ['class' => 'btn btn-primary float-right']) ?>
<br><br>

<?php

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_noticias',
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"

    ]);

?>

views/site/listar.php
<?php
use yii\grid\GridView;
use yii\helpers\Html;
use yii\bootstrap4\Carousel;

?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5"><?= $noticia->titulo ?></h1>
<h4><?= $noticia->texto ?></h4>
<br>
Comentarios de la noticia
<?php
$carusel=[];
$fotos=$noticia->getFotosCodigos()->all();//obteniendo datos de otra tabla con la que está relaccionada
foreach($fotos as $foto)
{
    $carusel[]=Html::img("@web/imgs/$foto->nombre",["width"=>300,"height"=>200]);
}

echo Carousel::widget([
    'items' => $carusel,
    'options'=>[
        'class' => 'mx-auto col-lg-8'
    ],
    'controls' => ['<i class="fas fa-arrow-left fa-3x"></i>','<i class="fas fa-arrow-right fa-3x"></i>']
]);

echo GridView::widget([
    'dataProvider' => $dataProvider,
    'layout' =>"{items}",
    'columns' =>[
        "texto",
        "fecha",
        [
            'class' => 'yii\grid\ActionColumn',
            'template' => '{editar} {eliminar}',
            'buttons' => [
                'editar' => function ($url,$model) {
                    return Html::a('<i class="fas fa-pencil-alt"></i>', 
                       ['site/editarcomentario',"codigo"=>$model->codigo]);
                },
                'eliminar' => function ($url,$model) {
                    return Html::a('<i class="far fa-trash-alt"></i>',
                            ['site/eliminarcomentario',"codigo"=>$model->codigo],
                            ['data' => ['confirm' => '¿Estas seguro que deseas borrar el comentario?',
                                        'method' => 'post']]);
                },
                        ]
        ]
                    ]         
]);
                
?>                

views/site/listar_fotos.php
<?php
use yii\grid\GridView;
use yii\helpers\Html;

echo GridView::widget([
    'dataProvider' => $dataProvider,
    'layout' =>"{items}",
    'columns' =>[
        "codigo",
        [
            'label'=>'Foto',
            'format'=>'raw',
            'value'=>function($foto){
                $url='@web/imgs/' . $foto->nombre;
                return Html::img($url,['class'=>'img-fluid', 'style'=>'width:300px']);
            }
        ],
        [
            'class' => 'yii\grid\ActionColumn',
            'template' => '{editar} {eliminar}',
            'buttons' => [
                'editar' => function ($url,$model) {
                    return Html::a('<i class="fas fa-pencil-alt"></i>', 
                       ['site/editarfoto',"codigo"=>$model->codigo]);
                },
                'eliminar' => function ($url,$model) {
                    return Html::a('<i class="far fa-trash-alt"></i>',
                            ['site/eliminarfoto',"codigo"=>$model->codigo],
                            ['data' => ['confirm' => '¿Estas seguro que deseas eliminar la foto?',
                                        'method' => 'post']]);
                },
                        ]
        ]
                    ]         
]);
                
?>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/noticias_fotos.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\NoticiasFotos */
/* @var $form ActiveForm */
?>
<div class="site-noticias_fotos">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'noticias_codigo')->dropDownList($listar_noticias) ?>
        <?= $form->field($model, 'fotos_codigo',['options'=>['class'=>'col-lg-3 p-0']])->checkboxList(
                $listar_fotos,
                ['prompt'=>'Selecciona una imagen','encode'=>false]
            ); ?>
        <?= $form->field($model, 'visitas') ?>
    
        <div class="form-group">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-noticias_fotos -->

views/site/salidanoticiafotos.php
<div class="row">
    <h2>Las imagenes añadidas a la noticia son</h2>
</div>

<?= \app\widgets\MostrarFotos::widget([
    "fotos" => $correctas
])?>

views/site/ver.php
<?php

use yii\widgets\DetailView;
use yii\helpers\Html;


echo DetailView::widget([
    'model' => $model
]);

echo Html::a('Eliminar', ['site/eliminarnoticia', 'codigo' => $model->codigo], ['class' => 'btn btn-danger']) 
        
?>